commit 2c8839bf64b3d30f83429dc8983ef77952fe1042
Author: freddy77 <freddy77>
Date:   Mon Dec 15 13:21:45 2008 +0000

    add and reuse tds_bcp_send_colmetadata

diff --git a/ChangeLog b/ChangeLog
index 547c5b4..5e66c86 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,8 @@
+Mon Dec 15 14:18:38 CET 2008    Frediano Ziglio <freddy77_A_gmail_D_com>
+	* include/tds.h src/ctlib/blk.c src/dblib/bcp.c src/tds/bulk.c:
+	- add and reuse tds_bcp_send_colmetadata
+	- fix some tdsdump_log in bulk.c
+
 Mon Dec 15 13:33:10 CET 2008    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* include/tds.h src/ctlib/blk.c src/dblib/bcp.c src/tds/bulk.c:
 	- add and reuse tds_bcp_send_record
@@ -1064,4 +1069,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog  truncated because of release
 	* ChangeLog-0.82 added because of release
 	
-$Id: ChangeLog,v 1.2680 2008/12/15 12:33:57 freddy77 Exp $
+$Id: ChangeLog,v 1.2681 2008/12/15 13:21:45 freddy77 Exp $
diff --git a/include/tds.h b/include/tds.h
index 02972ee..a25c018 100644
--- a/include/tds.h
+++ b/include/tds.h
@@ -20,7 +20,7 @@
 #ifndef _tds_h_
 #define _tds_h_
 
-/* $Id: tds.h,v 1.305 2008/12/15 12:33:57 freddy77 Exp $ */
+/* $Id: tds.h,v 1.306 2008/12/15 13:21:45 freddy77 Exp $ */
 
 #include <stdarg.h>
 #include <stdio.h>
@@ -1616,6 +1616,8 @@ typedef int  (*tds_bcp_get_col_data) (TDSBCPINFO *bulk, TDSCOLUMN *bcpcol, int o
 typedef void (*tds_bcp_null_error)   (TDSBCPINFO *bulk, int index, int offset);
 int tds_bcp_start_insert_stmt(TDSSOCKET *tds, TDSBCPINFO *bcpinfo);
 int tds_bcp_send_record(TDSSOCKET *tds, TDSBCPINFO *bcpinfo, tds_bcp_get_col_data get_col_data, tds_bcp_null_error null_error, int offset);
+int tds_bcp_send_colmetadata(TDSSOCKET *tds, TDSBCPINFO *bcpinfo);
+
 
 #define IS_TDS42(x) (x->major_version==4 && x->minor_version==2)
 #define IS_TDS46(x) (x->major_version==4 && x->minor_version==6)
diff --git a/src/ctlib/blk.c b/src/ctlib/blk.c
index 18f6560..52939f0 100644
--- a/src/ctlib/blk.c
+++ b/src/ctlib/blk.c
@@ -38,11 +38,10 @@
 #include "ctlib.h"
 #include "replacements.h"
 
-TDS_RCSID(var, "$Id: blk.c,v 1.45 2008/12/15 12:33:57 freddy77 Exp $");
+TDS_RCSID(var, "$Id: blk.c,v 1.46 2008/12/15 13:21:45 freddy77 Exp $");
 
 static void _blk_null_error(TDSBCPINFO *bcpinfo, int index, int offset);
 static int _blk_get_col_data(TDSBCPINFO *bulk, TDSCOLUMN *bcpcol, int offset);
-static CS_RETCODE _blk_send_colmetadata(CS_BLKDESC * blkdesc);
 static CS_RETCODE _rowxfer_in_init(CS_BLKDESC * blkdesc);
 static CS_RETCODE _blk_rowxfer_in(CS_BLKDESC * blkdesc, CS_INT rows_to_xfer, CS_INT * rows_xferred);
 static CS_RETCODE _blk_rowxfer_out(CS_BLKDESC * blkdesc, CS_INT rows_to_xfer, CS_INT * rows_xferred);
@@ -246,9 +245,8 @@ blk_done(CS_BLKDESC * blkdesc, CS_INT type, CS_INT * outrow)
 
 		tds->out_flag = TDS_BULK;
 
-		if (IS_TDS7_PLUS(tds)) {
-			_blk_send_colmetadata(blkdesc);
-		}
+		if (IS_TDS7_PLUS(tds))
+			tds_bcp_send_colmetadata(tds, &blkdesc->bcpinfo);
 
 		break;
 		
@@ -706,9 +704,8 @@ _blk_rowxfer_in(CS_BLKDESC * blkdesc, CS_INT rows_to_xfer, CS_INT * rows_xferred
 		/* set packet type to send bulk data */
 		tds->out_flag = TDS_BULK;
 
-		if (IS_TDS7_PLUS(tds)) {
-			_blk_send_colmetadata(blkdesc);
-		}
+		if (IS_TDS7_PLUS(tds))
+			tds_bcp_send_colmetadata(tds, &blkdesc->bcpinfo);
 
 		blkdesc->bcpinfo.xfer_init = 1;
 	} 
@@ -818,89 +815,6 @@ _rowxfer_in_init(CS_BLKDESC * blkdesc)
 	return CS_SUCCEED;
 }
 
-static CS_RETCODE
-_blk_send_colmetadata(CS_BLKDESC * blkdesc)
-{
-
-	TDSSOCKET *tds = blkdesc->con->tds_socket;
-	unsigned char colmetadata_token = 0x81;
-	TDSCOLUMN *bcpcol;
-	int i;
-	TDS_SMALLINT num_cols;
-
-	/* 
-	 * Deep joy! For TDS 8 we have to send a colmetadata message followed by row data 
-	 */
-	tds_put_byte(tds, colmetadata_token);	/* 0x81 */
-
-	num_cols = 0;
-	for (i = 0; i < blkdesc->bcpinfo.bindinfo->num_cols; i++) {
-		bcpcol = blkdesc->bcpinfo.bindinfo->columns[i];
-		if ((!blkdesc->bcpinfo.identity_insert_on && bcpcol->column_identity) || 
-			bcpcol->column_timestamp) {
-			continue;
-		}
-		num_cols++;
-	}
-
-	tds_put_smallint(tds, num_cols);
-
-	for (i = 0; i < blkdesc->bcpinfo.bindinfo->num_cols; i++) {
-		bcpcol = blkdesc->bcpinfo.bindinfo->columns[i];
-
-		/*
-		 * dont send the (meta)data for timestamp columns, or
-		 * identity columns (unless indentity_insert is enabled
-		 */
-
-		if ((!blkdesc->bcpinfo.identity_insert_on && bcpcol->column_identity) || 
-			bcpcol->column_timestamp) {
-			continue;
-		}
-
-		if (IS_TDS90(tds))
-			tds_put_int(tds, bcpcol->column_usertype);
-		else
-			tds_put_smallint(tds, bcpcol->column_usertype);
-		tds_put_smallint(tds, bcpcol->column_flags);
-		tds_put_byte(tds, bcpcol->on_server.column_type);
-
-		switch (bcpcol->column_varint_size) {
-		case 4:
-			tds_put_int(tds, bcpcol->column_size);
-			break;
-		case 2:
-			tds_put_smallint(tds, bcpcol->column_size);
-			break;
-		case 1:
-			tds_put_byte(tds, bcpcol->column_size);
-			break;
-		case 0:
-			break;
-		default:
-			break;
-		}
-
-		if (is_numeric_type(bcpcol->on_server.column_type)) {
-			tds_put_byte(tds, bcpcol->column_prec);
-			tds_put_byte(tds, bcpcol->column_scale);
-		}
-		if (IS_TDS8_PLUS(tds)
-			&& is_collate_type(bcpcol->on_server.column_type)) {
-			tds_put_n(tds, bcpcol->column_collation, 5);
-		}
-		if (is_blob_type(bcpcol->on_server.column_type)) {
-			tds_put_smallint(tds, strlen(blkdesc->bcpinfo.tablename));
-			tds_put_string(tds, blkdesc->bcpinfo.tablename, strlen(blkdesc->bcpinfo.tablename));
-		}
-		/* FIXME support multibyte string */
-		tds_put_byte(tds, bcpcol->column_namelen);
-		tds_put_string(tds, bcpcol->column_name, bcpcol->column_namelen);
-
-	}
-	return CS_SUCCEED;
-}
-
 static void
 _blk_null_error(TDSBCPINFO *bcpinfo, int index, int offset)
 {
diff --git a/src/dblib/bcp.c b/src/dblib/bcp.c
index 6a53df9..85b5e31 100644
--- a/src/dblib/bcp.c
+++ b/src/dblib/bcp.c
@@ -61,7 +61,7 @@
 #define MAX(a,b) ( (a) > (b) ? (a) : (b) )
 #endif
 
-TDS_RCSID(var, "$Id: bcp.c,v 1.175 2008/12/15 12:33:57 freddy77 Exp $");
+TDS_RCSID(var, "$Id: bcp.c,v 1.176 2008/12/15 13:21:45 freddy77 Exp $");
 
 #ifdef HAVE_FSEEKO
 typedef off_t offset_type;
@@ -82,7 +82,6 @@ static void _bcp_free_columns(DBPROCESS * dbproc);
 static void _bcp_null_error(TDSBCPINFO *bcpinfo, int index, int offset);
 static int _bcp_get_col_data(TDSBCPINFO *bcpinfo, TDSCOLUMN *bindcol, int offset);
 static int _bcp_no_get_col_data(TDSBCPINFO *bcpinfo, TDSCOLUMN *bindcol, int offset);
-static RETCODE _bcp_send_colmetadata(DBPROCESS *);
 static RETCODE _bcp_start_copy_in(DBPROCESS *);
 static RETCODE _bcp_start_new_batch(DBPROCESS *);
 
@@ -1631,9 +1630,8 @@ bcp_sendrow(DBPROCESS * dbproc)
 		tds->out_flag = TDS_BULK;
 		tds_set_state(tds, TDS_QUERYING);
 
-		if (IS_TDS7_PLUS(tds)) {
-			_bcp_send_colmetadata(dbproc);
-		}
+		if (IS_TDS7_PLUS(tds))
+			tds_bcp_send_colmetadata(tds, dbproc->bcpinfo);
 
 		dbproc->bcpinfo->xfer_init = 1;
 
@@ -1687,9 +1685,8 @@ _bcp_exec_in(DBPROCESS * dbproc, DBINT * rows_copied)
 	tds->out_flag = TDS_BULK;
 	tds_set_state(tds, TDS_QUERYING);
 
-	if (IS_TDS7_PLUS(tds)) {
-		_bcp_send_colmetadata(dbproc);
-	}
+	if (IS_TDS7_PLUS(tds))
+		tds_bcp_send_colmetadata(tds, dbproc->bcpinfo);
 
 	row_of_hostfile = 0;
 	rows_written_so_far = 0;
@@ -2060,9 +2057,8 @@ _bcp_start_new_batch(DBPROCESS * dbproc)
 	tds->out_flag = TDS_BULK;
 	tds_set_state(tds, TDS_QUERYING);
 
-	if (IS_TDS7_PLUS(tds)) {
-		_bcp_send_colmetadata(dbproc);
-	}
+	if (IS_TDS7_PLUS(tds))
+		tds_bcp_send_colmetadata(tds, dbproc->bcpinfo);
 	
 	return SUCCEED;
 }
@@ -2071,101 +2067,6 @@ _bcp_start_new_batch(DBPROCESS * dbproc)
  * \ingroup dblib_bcp_internal
  * \brief 
  *
- * \param dbproc contains all information needed by db-lib to manage communications with the server.
- * 
- * \return SUCCEED or FAIL.
- * \sa 	BCP_SETL(), bcp_batch(), bcp_bind(), bcp_colfmt(), bcp_colfmt_ps(), bcp_collen(), bcp_colptr(), bcp_columns(), bcp_control(), bcp_done(), bcp_exec(), bcp_getl(), bcp_init(), bcp_moretext(), bcp_options(), bcp_readfmt(), bcp_sendrow()
- */
-static RETCODE
-_bcp_send_colmetadata(DBPROCESS * dbproc)
-{
-	const static unsigned char colmetadata_token = 0x81;
-	TDSSOCKET *tds = dbproc->tds_socket;
-	TDSCOLUMN *bcpcol;
-	int i, num_cols;
-
-	tdsdump_log(TDS_DBG_FUNC, "_bcp_send_colmetadata(%p)\n", dbproc);
-	assert(dbproc);
-
-	/* 
-	 * Deep joy! For TDS 8 we have to send a colmetadata message followed by row data 
-	 */
-	tds_put_byte(tds, colmetadata_token);	/* 0x81 */
-
-	num_cols = 0;
-	for (i = 0; i < dbproc->bcpinfo->bindinfo->num_cols; i++) {
-		bcpcol = dbproc->bcpinfo->bindinfo->columns[i];
-		if ((!dbproc->bcpinfo->identity_insert_on && bcpcol->column_identity) ||
-			bcpcol->column_timestamp) {
-			continue;
-		}
-		num_cols++;
-	}
-
-	tds_put_smallint(tds, num_cols);
-
-	for (i = 0; i < dbproc->bcpinfo->bindinfo->num_cols; i++) {
-		bcpcol = dbproc->bcpinfo->bindinfo->columns[i];
-
-	/*
-	 * dont send the (meta)data for timestamp columns, or
-	 * identity columns (unless indentity_insert is enabled
-	 */
-
-        if ((!dbproc->bcpinfo->identity_insert_on && bcpcol->column_identity) ||
-            bcpcol->column_timestamp) {
-            continue;
-        }
-
-		if (IS_TDS90(tds))
-			tds_put_int(tds, bcpcol->column_usertype);
-		else
-			tds_put_smallint(tds, bcpcol->column_usertype);
-		tds_put_smallint(tds, bcpcol->column_flags);
-		tds_put_byte(tds, bcpcol->on_server.column_type);
-
-		switch (bcpcol->column_varint_size) {
-		case 4:
-			tds_put_int(tds, bcpcol->column_size);
-			break;
-		case 2:
-			tds_put_smallint(tds, bcpcol->column_size);
-			break;
-		case 1:
-			tds_put_byte(tds, bcpcol->column_size);
-			break;
-		case 0:
-			break;
-		default:
-			break;
-		}
-
-		if (is_numeric_type(bcpcol->on_server.column_type)) {
-			tds_put_byte(tds, bcpcol->column_prec);
-			tds_put_byte(tds, bcpcol->column_scale);
-		}
-		if (IS_TDS8_PLUS(tds)
-		    && is_collate_type(bcpcol->on_server.column_type)) {
-			tds_put_n(tds, bcpcol->column_collation, 5);
-		}
-		if (is_blob_type(bcpcol->on_server.column_type)) {
-			/* FIXME strlen return len in bytes not in characters required here */
-			tds_put_smallint(tds, strlen(dbproc->bcpinfo->tablename));
-			tds_put_string(tds, dbproc->bcpinfo->tablename, strlen(dbproc->bcpinfo->tablename));
-		}
-		/* FIXME column_namelen contains len in bytes not in characters required here */
-		tds_put_byte(tds, bcpcol->column_namelen);
-		tds_put_string(tds, bcpcol->column_name, bcpcol->column_namelen);
-
-	}
-
-	return SUCCEED;
-}
-
-/** 
- * \ingroup dblib_bcp_internal
- * \brief 
- *
  * \param buffer 
  * \param size 
  * \param f 
diff --git a/src/tds/bulk.c b/src/tds/bulk.c
index ed99070..89f0b9a 100644
--- a/src/tds/bulk.c
+++ b/src/tds/bulk.c
@@ -42,7 +42,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: bulk.c,v 1.2 2008/12/15 12:33:57 freddy77 Exp $");
+TDS_RCSID(var, "$Id: bulk.c,v 1.3 2008/12/15 13:21:45 freddy77 Exp $");
 
 typedef struct tds_pbcb
 {
@@ -344,7 +344,7 @@ tds_bcp_send_record(TDSSOCKET *tds, TDSBCPINFO *bcpinfo, tds_bcp_get_col_data ge
 			}
 
 			if ((get_col_data(bcpinfo, bindcol, offset)) != TDS_SUCCEED) {
-				tdsdump_log(TDS_DBG_INFO1, "blk_get_colData (column %d) failed\n", i + 1);
+				tdsdump_log(TDS_DBG_INFO1, "get_col_data (column %d) failed\n", i + 1);
 	 			return TDS_FAIL;
 			}
 			tdsdump_log(TDS_DBG_INFO1, "gotten column %d length %d null %d\n",
@@ -522,7 +522,7 @@ tds_bcp_add_fixed_columns(TDSBCPINFO *bcpinfo, tds_bcp_get_col_data get_col_data
 	assert(bcpinfo);
 	assert(rowbuffer);
 
-	tdsdump_log(TDS_DBG_FUNC, "tds_bcp_add_fixed_columns(%p, %p, %d)\n", bcpinfo, rowbuffer, start);
+	tdsdump_log(TDS_DBG_FUNC, "tds_bcp_add_fixed_columns(%p, %p, %p, %d, %p, %d)\n", bcpinfo, get_col_data, null_error, offset, rowbuffer, start);
 
 	for (i = 0; i < bcpinfo->bindinfo->num_cols; i++) {
 
@@ -533,7 +533,7 @@ tds_bcp_add_fixed_columns(TDSBCPINFO *bcpinfo, tds_bcp_get_col_data get_col_data
 			tdsdump_log(TDS_DBG_FUNC, "tds_bcp_add_fixed_columns column %d is a fixed column\n", i + 1);
 
 			if ((get_col_data(bcpinfo, bcpcol, offset)) != TDS_SUCCEED) {
-				tdsdump_log(TDS_DBG_INFO1, "bcp_get_colData (column %d) failed\n", i + 1);
+				tdsdump_log(TDS_DBG_INFO1, "get_col_data (column %d) failed\n", i + 1);
 		 		return TDS_FAIL;
 			}
 
@@ -695,3 +695,91 @@ tds_bcp_add_variable_columns(TDSBCPINFO *bcpinfo, tds_bcp_get_col_data get_col_d
 
 	return ncols == 0? start : row_pos;
 }
+
+/** 
+ * \return TDS_SUCCEED or TDS_FAIL.
+ */
+int
+tds_bcp_send_colmetadata(TDSSOCKET *tds, TDSBCPINFO *bcpinfo)
+{
+	const static unsigned char colmetadata_token = 0x81;
+	TDSCOLUMN *bcpcol;
+	int i, num_cols;
+
+	tdsdump_log(TDS_DBG_FUNC, "tds_bcp_send_colmetadata(%p, %p)\n", tds, bcpinfo);
+	assert(tds && bcpinfo);
+
+	/* 
+	 * Deep joy! For TDS 8 we have to send a colmetadata message followed by row data 
+	 */
+	tds_put_byte(tds, colmetadata_token);	/* 0x81 */
+
+	num_cols = 0;
+	for (i = 0; i < bcpinfo->bindinfo->num_cols; i++) {
+		bcpcol = bcpinfo->bindinfo->columns[i];
+		if ((!bcpinfo->identity_insert_on && bcpcol->column_identity) || 
+			bcpcol->column_timestamp) {
+			continue;
+		}
+		num_cols++;
+	}
+
+	tds_put_smallint(tds, num_cols);
+
+	for (i = 0; i < bcpinfo->bindinfo->num_cols; i++) {
+		bcpcol = bcpinfo->bindinfo->columns[i];
+
+		/*
+		 * dont send the (meta)data for timestamp columns, or
+		 * identity columns (unless indentity_insert is enabled
+		 */
+
+		if ((!bcpinfo->identity_insert_on && bcpcol->column_identity) || 
+			bcpcol->column_timestamp) {
+			continue;
+		}
+
+		if (IS_TDS90(tds))
+			tds_put_int(tds, bcpcol->column_usertype);
+		else
+			tds_put_smallint(tds, bcpcol->column_usertype);
+		tds_put_smallint(tds, bcpcol->column_flags);
+		tds_put_byte(tds, bcpcol->on_server.column_type);
+
+		switch (bcpcol->column_varint_size) {
+		case 4:
+			tds_put_int(tds, bcpcol->column_size);
+			break;
+		case 2:
+			tds_put_smallint(tds, bcpcol->column_size);
+			break;
+		case 1:
+			tds_put_byte(tds, bcpcol->column_size);
+			break;
+		case 0:
+			break;
+		default:
+			break;
+		}
+
+		if (is_numeric_type(bcpcol->on_server.column_type)) {
+			tds_put_byte(tds, bcpcol->column_prec);
+			tds_put_byte(tds, bcpcol->column_scale);
+		}
+		if (IS_TDS8_PLUS(tds)
+			&& is_collate_type(bcpcol->on_server.column_type)) {
+			tds_put_n(tds, bcpcol->column_collation, 5);
+		}
+		if (is_blob_type(bcpcol->on_server.column_type)) {
+			/* FIXME strlen return len in bytes not in characters required here */
+			tds_put_smallint(tds, strlen(bcpinfo->tablename));
+			tds_put_string(tds, bcpinfo->tablename, strlen(bcpinfo->tablename));
+		}
+		/* FIXME support multibyte string */
+		tds_put_byte(tds, bcpcol->column_namelen);
+		tds_put_string(tds, bcpcol->column_name, bcpcol->column_namelen);
+
+	}
+
+	return TDS_SUCCEED;
+}

